Simplify the (system foreign) API.
[bpt/guile.git] / maint.mk
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
4
5 ## Copyright (C) 2001-2010 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <http://www.gnu.org/licenses/>.
19
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
23
24 # Override this in cfg.mk if you use a non-standard build-aux directory.
25 build_aux ?= $(srcdir)/build-aux
26
27 # Do not save the original name or timestamp in the .tar.gz file.
28 # Use --rsyncable if available.
29 gzip_rsyncable := \
30 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
31 && printf %s --rsyncable)
32 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
33
34 GIT = git
35 VC = $(GIT)
36 VC-tag = git tag -s -m '$(VERSION)' -u '$(gpg_key_ID)'
37
38 VC_LIST = $(build_aux)/vc-list-files -C $(srcdir)
39
40 # You can override this variable in cfg.mk to set your own regexp
41 # matching files to ignore.
42 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
43
44 # This is to preprocess robustly the output of $(VC_LIST), so that even
45 # when $(srcdir) is a pathological name like "....", the leading sed command
46 # removes only the intended prefix.
47 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
48
49 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
50 # when $(srcdir) is not ".".
51 ifeq ($(srcdir),.)
52 _prepend_srcdir_prefix =
53 else
54 _prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
55 endif
56
57 # In order to be able to consistently filter "."-relative names,
58 # (i.e., with no $(srcdir) prefix), this definition is careful to
59 # remove any $(srcdir) prefix, and to restore what it removes.
60 VC_LIST_EXCEPT = \
61 $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
62 | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
63 else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
64 | grep -Ev -e '$(VC_LIST_ALWAYS_EXCLUDE_REGEX)' \
65 $(_prepend_srcdir_prefix)
66
67 ifeq ($(origin prev_version_file), undefined)
68 prev_version_file = $(srcdir)/.prev-version
69 endif
70
71 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
72 VERSION_REGEXP = $(subst .,\.,$(VERSION))
73 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
74
75 ifeq ($(VC),$(GIT))
76 this-vc-tag = v$(VERSION)
77 this-vc-tag-regexp = v$(VERSION_REGEXP)
78 else
79 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
80 tag-this-version = $(subst .,_,$(VERSION))
81 this-vc-tag = $(tag-package)-$(tag-this-version)
82 this-vc-tag-regexp = $(this-vc-tag)
83 endif
84 my_distdir = $(PACKAGE)-$(VERSION)
85
86 # Old releases are stored here.
87 release_archive_dir ?= ../release
88
89 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
90 # Use alpha.gnu.org for alpha and beta releases.
91 # Use ftp.gnu.org for stable releases.
92 gnu_ftp_host-alpha = alpha.gnu.org
93 gnu_ftp_host-beta = alpha.gnu.org
94 gnu_ftp_host-stable = ftp.gnu.org
95 gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
96
97 ifeq ($(gnu_rel_host),ftp.gnu.org)
98 url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
99 else
100 url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
101 endif
102
103 # Override this in cfg.mk if you are using a different format in your
104 # NEWS file.
105 today = $(shell date +%Y-%m-%d)
106 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
107
108 # Prevent programs like 'sort' from considering distinct strings to be equal.
109 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
110 export LC_ALL = C
111
112 ## --------------- ##
113 ## Sanity checks. ##
114 ## --------------- ##
115
116 _cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
117
118 # Collect the names of rules starting with `sc_'.
119 syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
120 $(srcdir)/$(ME) $(_cfg_mk)))
121 .PHONY: $(syntax-check-rules)
122
123 local-checks-available = \
124 $(syntax-check-rules)
125 .PHONY: $(local-checks-available)
126
127 # Arrange to print the name of each syntax-checking rule just before running it.
128 $(syntax-check-rules): %: %.m
129 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
130 .PHONY: $(sc_m_rules_)
131 $(sc_m_rules_):
132 @echo $(patsubst sc_%.m, %, $@)
133 @date +%s.%N > .sc-start-$(basename $@)
134
135 # Compute and print the elapsed time for each syntax-check rule.
136 sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
137 .PHONY: $(sc_z_rules_)
138 $(sc_z_rules_): %.z: %
139 @end=$$(date +%s.%N); \
140 start=$$(cat .sc-start-$*); \
141 rm -f .sc-start-$*; \
142 awk -v s=$$start -v e=$$end \
143 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
144
145 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
146 # that computes and prints elapsed time.
147 local-check := \
148 $(patsubst sc_%, sc_%.z, \
149 $(filter-out $(local-checks-to-skip), $(local-checks-available)))
150
151 syntax-check: $(local-check)
152
153 # _sc_search_regexp
154 #
155 # This macro searches for a given construct in the selected files and
156 # then takes some action.
157 #
158 # Parameters (shell variables):
159 #
160 # prohibit | require
161 #
162 # Regular expression (ERE) denoting either a forbidden construct
163 # or a required construct. Those arguments are exclusive.
164 #
165 # in_vc_files | in_files
166 #
167 # grep-E-style regexp denoting the files to check. If no files
168 # are specified the default are all the files that are under
169 # version control.
170 #
171 # containing | non_containing
172 #
173 # Select the files (non) containing strings matching this regexp.
174 # If both arguments are specified then CONTAINING takes
175 # precedence.
176 #
177 # with_grep_options
178 #
179 # Extra options for grep.
180 #
181 # ignore_case
182 #
183 # Ignore case.
184 #
185 # halt
186 #
187 # Message to display before to halting execution.
188
189 # By default, _sc_search_regexp does not ignore case.
190 export ignore_case =
191 _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
192
193 define _sc_say_and_exit
194 dummy=; : so we do not need a semicolon before each use; \
195 { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
196 endef
197
198 # _sc_search_regexp used to be named _prohibit_regexp. However,
199 # upgrading to the new definition and leaving the old name undefined
200 # would usually convert each custom rule using $(_prohibit_regexp)
201 # (usually defined in cfg.mk) into a no-op. This definition ensures
202 # that people know right away if they're still using the old name.
203 # FIXME: remove in 2012.
204 _prohibit_regexp = \
205 $(error '*** you need to s/_prohibit_regexp/_sc_search_regexp/, and adapt')
206
207 define _sc_search_regexp
208 dummy=; : so we do not need a semicolon before each use; \
209 \
210 : Check arguments; \
211 test -n "$$prohibit" && test -n "$$require" \
212 && { msg='Cannot specify both prohibit and require' \
213 $(_sc_say_and_exit) } || :; \
214 test -z "$$prohibit" && test -z "$$require" \
215 && { msg='Should specify either prohibit or require' \
216 $(_sc_say_and_exit) } || :; \
217 test -n "$$in_vc_files" && test -n "$$in_files" \
218 && { msg='Cannot specify both in_vc_files and in_files' \
219 $(_sc_say_and_exit) } || :; \
220 test "x$$halt" != x \
221 || { msg='halt not defined' $(_sc_say_and_exit) }; \
222 \
223 : Filter by file name; \
224 if test -n "$$in_files"; then \
225 files=$$(find $(srcdir) | grep -E "$$in_files"); \
226 else \
227 files=$$($(VC_LIST_EXCEPT)); \
228 if test -n "$$in_vc_files"; then \
229 files=$$(echo "$$files" | grep -E "$$in_vc_files"); \
230 fi; \
231 fi; \
232 \
233 : Filter by content; \
234 test -n "$$files" && test -n "$$containing" \
235 && { files=$$(grep -l "$$containing" $$files); } || :; \
236 test -n "$$files" && test -n "$$non_containing" \
237 && { files=$$(grep -vl "$$non_containing" $$files); } || :; \
238 \
239 : Check for the construct; \
240 if test -n "$$files"; then \
241 if test -n "$$prohibit"; then \
242 grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
243 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
244 else \
245 grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
246 | grep . \
247 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
248 fi \
249 else :; \
250 fi || :;
251 endef
252
253 sc_avoid_if_before_free:
254 @$(build_aux)/useless-if-before-free \
255 $(useless_free_options) \
256 $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \
257 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
258 exit 1; } || :
259
260 sc_cast_of_argument_to_free:
261 @prohibit='\<free *\( *\(' halt='don'\''t cast free argument' \
262 $(_sc_search_regexp)
263
264 sc_cast_of_x_alloc_return_value:
265 @prohibit='\*\) *x(m|c|re)alloc\>' \
266 halt='don'\''t cast x*alloc return value' \
267 $(_sc_search_regexp)
268
269 sc_cast_of_alloca_return_value:
270 @prohibit='\*\) *alloca\>' \
271 halt='don'\''t cast alloca return value' \
272 $(_sc_search_regexp)
273
274 sc_space_tab:
275 @prohibit='[ ] ' \
276 halt='found SPACE-TAB sequence; remove the SPACE' \
277 $(_sc_search_regexp)
278
279 # Don't use *scanf or the old ato* functions in `real' code.
280 # They provide no error checking mechanism.
281 # Instead, use strto* functions.
282 sc_prohibit_atoi_atof:
283 @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \
284 halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
285 $(_sc_search_regexp)
286
287 # Use STREQ rather than comparing strcmp == 0, or != 0.
288 sc_prohibit_strcmp:
289 @grep -nE '! *str''cmp *\(|\<str''cmp *\([^)]+\) *==' \
290 $$($(VC_LIST_EXCEPT)) \
291 | grep -vE ':# *define STREQ\(' && \
292 { echo '$(ME): use STREQ in place of the above uses of str''cmp' \
293 1>&2; exit 1; } || :
294
295 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
296 # Convert all uses automatically, via these two commands:
297 # git grep -l '\<exit *(1)' \
298 # | grep -vEf .x-sc_prohibit_magic_number_exit \
299 # | xargs --no-run-if-empty \
300 # perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
301 # git grep -l '\<exit *(0)' \
302 # | grep -vEf .x-sc_prohibit_magic_number_exit \
303 # | xargs --no-run-if-empty \
304 # perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
305 sc_prohibit_magic_number_exit:
306 @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
307 halt='use EXIT_* values rather than magic number' \
308 $(_sc_search_regexp)
309
310 # Using EXIT_SUCCESS as the first argument to error is misleading,
311 # since when that parameter is 0, error does not exit. Use `0' instead.
312 sc_error_exit_success:
313 @prohibit='error *\(EXIT_SUCCESS,' \
314 in_vc_files='\.[chly]$$' \
315 halt='found error (EXIT_SUCCESS' \
316 $(_sc_search_regexp)
317
318 # `FATAL:' should be fully upper-cased in error messages
319 # `WARNING:' should be fully upper-cased, or fully lower-cased
320 sc_error_message_warn_fatal:
321 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
322 | grep -E '"Warning|"Fatal|"fatal' && \
323 { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
324 exit 1; } || :
325
326 # Error messages should not start with a capital letter
327 sc_error_message_uppercase:
328 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
329 | grep -E '"[A-Z]' \
330 | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
331 { echo '$(ME): found capitalized error message' 1>&2; \
332 exit 1; } || :
333
334 # Error messages should not end with a period
335 sc_error_message_period:
336 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
337 | grep -E '[^."]\."' && \
338 { echo '$(ME): found error message ending in period' 1>&2; \
339 exit 1; } || :
340
341 sc_file_system:
342 @prohibit=file''system \
343 ignore_case=1 \
344 halt='found use of "file''system"; spell it "file system"' \
345 $(_sc_search_regexp)
346
347 # Don't use cpp tests of this symbol. All code assumes config.h is included.
348 sc_prohibit_have_config_h:
349 @prohibit='^# *if.*HAVE''_CONFIG_H' \
350 halt='found use of HAVE''_CONFIG_H; remove' \
351 $(_sc_search_regexp)
352
353 # Nearly all .c files must include <config.h>. However, we also permit this
354 # via inclusion of a package-specific header, if cfg.mk specified one.
355 # config_h_header must be suitable for grep -E.
356 config_h_header ?= <config\.h>
357 sc_require_config_h:
358 @require='^# *include $(config_h_header)' \
359 in_vc_files='\.c$$' \
360 halt='the above files do not include <config.h>' \
361 $(_sc_search_regexp)
362
363 # You must include <config.h> before including any other header file.
364 # This can possibly be via a package-specific header, if given by cfg.mk.
365 sc_require_config_h_first:
366 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
367 fail=0; \
368 for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \
369 grep '^# *include\>' $$i | sed 1q \
370 | grep -E '^# *include $(config_h_header)' > /dev/null \
371 || { echo $$i; fail=1; }; \
372 done; \
373 test $$fail = 1 && \
374 { echo '$(ME): the above files include some other header' \
375 'before <config.h>' 1>&2; exit 1; } || :; \
376 else :; \
377 fi
378
379 sc_prohibit_HAVE_MBRTOWC:
380 @prohibit='\bHAVE_MBRTOWC\b' \
381 halt="do not use $$prohibit; it is always defined" \
382 $(_sc_search_regexp)
383
384 # To use this "command" macro, you must first define two shell variables:
385 # h: the header, enclosed in <> or ""
386 # re: a regular expression that matches IFF something provided by $h is used.
387 define _sc_header_without_use
388 dummy=; : so we do not need a semicolon before each use; \
389 h_esc=`echo "$$h"|sed 's/\./\\\\./g'`; \
390 if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
391 files=$$(grep -l '^# *include '"$$h_esc" \
392 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
393 grep -LE "$$re" $$files | grep . && \
394 { echo "$(ME): the above files include $$h but don't use it" \
395 1>&2; exit 1; } || :; \
396 else :; \
397 fi
398 endef
399
400 # Prohibit the inclusion of assert.h without an actual use of assert.
401 sc_prohibit_assert_without_use:
402 @h='<assert.h>' re='\<assert *\(' $(_sc_header_without_use)
403
404 # Prohibit the inclusion of close-stream.h without an actual use.
405 sc_prohibit_close_stream_without_use:
406 @h='"close-stream.h"' re='\<close_stream *\(' $(_sc_header_without_use)
407
408 # Prohibit the inclusion of getopt.h without an actual use.
409 sc_prohibit_getopt_without_use:
410 @h='<getopt.h>' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
411
412 # Don't include quotearg.h unless you use one of its functions.
413 sc_prohibit_quotearg_without_use:
414 @h='"quotearg.h"' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
415
416 # Don't include quote.h unless you use one of its functions.
417 sc_prohibit_quote_without_use:
418 @h='"quote.h"' re='\<quote(_n)? *\(' $(_sc_header_without_use)
419
420 # Don't include this header unless you use one of its functions.
421 sc_prohibit_long_options_without_use:
422 @h='"long-options.h"' re='\<parse_long_options *\(' \
423 $(_sc_header_without_use)
424
425 # Don't include this header unless you use one of its functions.
426 sc_prohibit_inttostr_without_use:
427 @h='"inttostr.h"' re='\<(off|[iu]max|uint)tostr *\(' \
428 $(_sc_header_without_use)
429
430 # Don't include this header unless you use one of its functions.
431 sc_prohibit_ignore_value_without_use:
432 @h='"ignore-value.h"' re='\<ignore_(value|ptr) *\(' \
433 $(_sc_header_without_use)
434
435 # Don't include this header unless you use one of its functions.
436 sc_prohibit_error_without_use:
437 @h='"error.h"' \
438 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
439 $(_sc_header_without_use)
440
441 # Don't include xalloc.h unless you use one of its functions.
442 # Consider these symbols:
443 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
444 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
445 # Divide into two sets on case, and filter each through this:
446 # | sort | perl -MRegexp::Assemble -le \
447 # 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
448 # Note this was produced by the above:
449 # _xa1 = \
450 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
451 # But we can do better, in at least two ways:
452 # 1) take advantage of two "dup"-suffixed strings:
453 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
454 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
455 # "char|[cmz]"
456 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
457 _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
458 _xa2 = X([CZ]|N?M)ALLOC
459 sc_prohibit_xalloc_without_use:
460 @h='"xalloc.h"' \
461 re='\<($(_xa1)|$(_xa2)) *\('\
462 $(_sc_header_without_use)
463
464 # Extract function names:
465 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
466 _hash_re = \
467 clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
468 _hash_fn = \<($(_hash_re)) *\(
469 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
470 sc_prohibit_hash_without_use:
471 @h='"hash.h"' \
472 re='$(_hash_fn)|$(_hash_struct)'\
473 $(_sc_header_without_use)
474
475 sc_prohibit_hash_pjw_without_use:
476 @h='"hash-pjw.h"' \
477 re='\<hash_pjw *\(' \
478 $(_sc_header_without_use)
479
480 sc_prohibit_safe_read_without_use:
481 @h='"safe-read.h"' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
482 $(_sc_header_without_use)
483
484 sc_prohibit_argmatch_without_use:
485 @h='"argmatch.h"' \
486 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
487 $(_sc_header_without_use)
488
489 sc_prohibit_canonicalize_without_use:
490 @h='"canonicalize.h"' \
491 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
492 $(_sc_header_without_use)
493
494 sc_prohibit_root_dev_ino_without_use:
495 @h='"root-dev-ino.h"' \
496 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
497 $(_sc_header_without_use)
498
499 sc_prohibit_openat_without_use:
500 @h='"openat.h"' \
501 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
502 $(_sc_header_without_use)
503
504 # Prohibit the inclusion of c-ctype.h without an actual use.
505 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
506 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
507 sc_prohibit_c_ctype_without_use:
508 @h='[<"]c-ctype.h[">]' re='\<c_($(ctype_re)) *\(' \
509 $(_sc_header_without_use)
510
511 _empty =
512 _sp = $(_empty) $(_empty)
513 # The following list was generated by running:
514 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
515 # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
516 _sig_functions = \
517 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
518 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
519 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
520 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
521 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
522 # The following were extracted from "man signal.h" manually.
523 _sig_types_and_consts = \
524 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
525 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
526 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
527 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
528 sigstack sigval stack_t ucontext_t
529 # generated via this:
530 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
531 _sig_names = \
532 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
533 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
534 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
535 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
536 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
537 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
538 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
539 SIGXCPU SIGXFSZ
540 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
541
542 # Prohibit the inclusion of signal.h without an actual use.
543 sc_prohibit_signal_without_use:
544 @h='<signal.h>' \
545 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
546 $(_sc_header_without_use)
547
548 # Prohibit the inclusion of strings.h without a sensible use.
549 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
550 sc_prohibit_strings_without_use:
551 @h='<strings.h>' \
552 re='\<(strn?casecmp|ffs(ll)?)\>' \
553 $(_sc_header_without_use)
554
555 # Get the list of symbol names with this:
556 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/intprops.h|grep -v '^s'|fmt
557 _intprops_names = \
558 TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \
559 TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
560 INT_STRLEN_BOUND INT_BUFSIZE_BOUND
561 _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
562 # Prohibit the inclusion of intprops.h without an actual use.
563 sc_prohibit_intprops_without_use:
564 @h='"intprops.h"' \
565 re='\<($(_intprops_syms_re)) *\(' \
566 $(_sc_header_without_use)
567
568 sc_obsolete_symbols:
569 @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
570 halt='do not use HAVE''_FCNTL_H or O'_NDELAY \
571 $(_sc_search_regexp)
572
573 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
574
575 # Each nonempty ChangeLog line must start with a year number, or a TAB.
576 sc_changelog:
577 @prohibit='^[^12 ]' \
578 in_vc_files='^ChangeLog$$' \
579 halt='found unexpected prefix in a ChangeLog' \
580 $(_sc_search_regexp)
581
582 # Ensure that each .c file containing a "main" function also
583 # calls set_program_name.
584 sc_program_name:
585 @require='set_program_name *\(m?argv\[0\]\);' \
586 in_vc_files='\.c$$' \
587 containing='^main *(' \
588 halt='the above files do not call set_program_name' \
589 $(_sc_search_regexp)
590
591 # Require that the final line of each test-lib.sh-using test be this one:
592 # Exit $fail
593 # Note: this test requires GNU grep's --label= option.
594 Exit_witness_file ?= tests/test-lib.sh
595 Exit_base := $(notdir $(Exit_witness_file))
596 sc_require_test_exit_idiom:
597 @if test -f $(srcdir)/$(Exit_witness_file); then \
598 die=0; \
599 for i in $$(grep -l -F 'srcdir/$(Exit_base)' \
600 $$($(VC_LIST) tests)); do \
601 tail -n1 $$i | grep '^Exit .' > /dev/null \
602 && : || { die=1; echo $$i; } \
603 done; \
604 test $$die = 1 && \
605 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
606 echo 1>&2 'Exit something'; \
607 exit 1; } || :; \
608 fi
609
610 sc_the_the:
611 @prohibit='\<the ''the\>' \
612 ignore_case=1 \
613 halt='found use of "the ''the";' \
614 $(_sc_search_regexp)
615
616 sc_trailing_blank:
617 @prohibit='[ ]$$' \
618 halt='found trailing blank(s)' \
619 $(_sc_search_regexp)
620
621 # Match lines like the following, but where there is only one space
622 # between the options and the description:
623 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
624 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
625 sc_two_space_separator_in_usage:
626 @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
627 halt='help2man requires at least two spaces between an option and its description'\
628 $(_sc_search_regexp)
629
630 # Look for diagnostics that aren't marked for translation.
631 # This won't find any for which error's format string is on a separate line.
632 sc_unmarked_diagnostics:
633 @grep -nE \
634 '\<error *\([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT)) \
635 | grep -v '_''(' && \
636 { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
637 exit 1; } || :
638
639 # Avoid useless parentheses like those in this example:
640 # #if defined (SYMBOL) || defined (SYM2)
641 sc_useless_cpp_parens:
642 @prohibit='^# *if .*defined *\(' \
643 halt='found useless parentheses in cpp directive' \
644 $(_sc_search_regexp)
645
646 # List headers for which HAVE_HEADER_H is always true, assuming you are
647 # using the appropriate gnulib module. CAUTION: for each "unnecessary"
648 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
649 # requires the gnulib module that guarantees the usability of that header.
650 gl_assured_headers_ = \
651 cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
652
653 # Convert the list of names to upper case, and replace each space with "|".
654 az_ = abcdefghijklmnopqrstuvwxyz
655 AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
656 gl_header_upper_case_or_ = \
657 $$($(gl_assured_headers_) \
658 | tr $(az_)/.- $(AZ_)___ \
659 | tr -s ' ' '|' \
660 )
661 sc_prohibit_always_true_header_tests:
662 @or=$(gl_header_upper_case_or_); \
663 re="HAVE_($$or)_H"; \
664 prohibit='\<'"$$re"'\>' \
665 halt='do not test the above HAVE_<header>_H symbol(s);\n'\
666 ' with the corresponding gnulib module, they are always true' \
667 $(_sc_search_regexp)
668
669 # ==================================================================
670 gl_other_headers_ ?= \
671 intprops.h \
672 openat.h \
673 stat-macros.h
674
675 # Perl -lne code to extract "significant" cpp-defined symbols from a
676 # gnulib header file, eliminating a few common false-positives.
677 gl_extract_significant_defines_ = \
678 /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
679 && $$2 !~ /(?:rpl_|_used_without_)/\
680 && $$1 !~ /^(?:NSIG|ATTRIBUTE_NORETURN)$$/\
681 and print $$1
682
683 # Create a list of regular expressions matching the names
684 # of macros that are guaranteed to be defined by parts of gnulib.
685 define def_sym_regex
686 gen_h=$(gl_generated_headers_); \
687 (cd $(gnulib_dir)/lib; \
688 for f in *.in.h $(gl_other_headers_); do \
689 perl -lne '$(gl_extract_significant_defines_)' $$f; \
690 done; \
691 ) | sort -u \
692 | grep -Ev '^ATTRIBUTE_NORETURN' \
693 | sed 's/^/^ *# *(define|undef) */;s/$$/\\>/'
694 endef
695
696 # Don't define macros that we already get from gnulib header files.
697 sc_prohibit_always-defined_macros:
698 @if test -d $(gnulib_dir); then \
699 case $$(echo all: | grep -l -f - Makefile) in Makefile);; *) \
700 echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
701 esac; \
702 $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT)) \
703 && { echo '$(ME): define the above via some gnulib .h file' \
704 1>&2; exit 1; } || :; \
705 fi
706 # ==================================================================
707
708 # Prohibit checked in backup files.
709 sc_prohibit_backup_files:
710 @$(VC_LIST) | grep '~$$' && \
711 { echo '$(ME): found version controlled backup file' 1>&2; \
712 exit 1; } || :
713
714 # Require the latest GPL.
715 sc_GPL_version:
716 @prohibit='either ''version [^3]' \
717 halt='GPL vN, N!=3' \
718 $(_sc_search_regexp)
719
720 # Require the latest GFDL. Two regexp, since some .texi files end up
721 # line wrapping between 'Free Documentation License,' and 'Version'.
722 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
723 sc_GFDL_version:
724 @prohibit='$(_GFDL_regexp)' \
725 halt='GFDL vN, N!=3' \
726 $(_sc_search_regexp)
727
728 # Don't use Texinfo @acronym{} as it is not a good idea.
729 texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
730 sc_texinfo_acronym:
731 @prohibit='@acronym\{' \
732 in_vc_files='$(texinfo_suffix_re_)' \
733 halt='found use of Texinfo @acronym{}' \
734 $(_sc_search_regexp)
735
736 cvs_keywords = \
737 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
738
739 sc_prohibit_cvs_keyword:
740 @prohibit='\$$($(cvs_keywords))\$$' \
741 halt='do not use CVS keyword expansion' \
742 $(_sc_search_regexp)
743
744 # This Perl code is slightly obfuscated. Not only is each "$" doubled
745 # because it's in a Makefile, but the $$c's are comments; we cannot
746 # use "#" due to the way the script ends up concatenated onto one line.
747 # It would be much more concise, and would produce better output (including
748 # counts) if written as:
749 # perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
750 # but that would be far less efficient, reading the entire contents
751 # of each file, rather than just the last two bytes of each.
752 #
753 # This is a perl script that is expected to be the single-quoted argument
754 # to a command-line "-le". The remaining arguments are file names.
755 # Print the name of each file that ends in two or more newline bytes.
756 # Exit nonzero if at least one such file is found, otherwise, exit 0.
757 # Warn about, but otherwise ignore open failure. Ignore seek/read failure.
758 #
759 # Use this if you want to remove trailing empty lines from selected files:
760 # perl -pi -0777 -e 's/\n\n+$/\n/' files...
761 #
762 detect_empty_lines_at_EOF_ = \
763 foreach my $$f (@ARGV) \
764 { \
765 open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \
766 my $$p = sysseek (F, -2, 2); \
767 my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
768 my $$last_two_bytes; \
769 defined $$p and $$p = sysread F, $$last_two_bytes, 2; \
770 close F; \
771 $$c = "ignore read failure"; \
772 $$p && $$last_two_bytes eq "\n\n" and (print $$f), $$fail=1; \
773 } \
774 END { exit defined $$fail }
775 sc_prohibit_empty_lines_at_EOF:
776 @perl -le '$(detect_empty_lines_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
777 || { echo '$(ME): the above files end with empty line(s)' \
778 1>&2; exit 1; } || :; \
779
780 # Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
781 # This is a bit of a kludge, since it prevents use of the string
782 # even in comments, but for now it does the job with no false positives.
783 sc_prohibit_stat_st_blocks:
784 @prohibit='[.>]st_blocks' \
785 halt='do not use st_blocks; use ST_NBLOCKS' \
786 $(_sc_search_regexp)
787
788 # Make sure we don't define any S_IS* macros in src/*.c files.
789 # They're already defined via gnulib's sys/stat.h replacement.
790 sc_prohibit_S_IS_definition:
791 @prohibit='^ *# *define *S_IS' \
792 halt='do not define S_IS* macros; include <sys/stat.h>' \
793 $(_sc_search_regexp)
794
795 _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
796 _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
797 # Using test's -a and -o operators is not portable.
798 # We prefer test over [, since the latter is spelled [[ in configure.ac.
799 sc_prohibit_test_minus_ao:
800 @prohibit='(\<test| \[+) .+ -[ao] ' \
801 halt='$(_ptm1); $(_ptm2)' \
802 $(_sc_search_regexp)
803
804 # Each program that uses proper_name_utf8 must link with one of the
805 # ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
806 # The perl -0777 invocation below extracts the possibly-multi-line
807 # definition of LDADD from the appropriate Makefile.am and exits 0
808 # when it contains "ICONV".
809 sc_proper_name_utf8_requires_ICONV:
810 @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
811 if test "x$$progs" != x; then \
812 fail=0; \
813 for p in $$progs; do \
814 dir=$$(dirname "$$p"); \
815 perl -0777 \
816 -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
817 $$dir/Makefile.am && continue; \
818 base=$$(basename "$$p" .c); \
819 grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
820 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
821 done; \
822 test $$fail = 1 && \
823 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
824 exit 1; } || :; \
825 fi
826
827 # Warn about "c0nst struct Foo const foo[]",
828 # but not about "char const *const foo" or "#define const const".
829 sc_redundant_const:
830 @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
831 halt='redundant "const" in declarations' \
832 $(_sc_search_regexp)
833
834 sc_const_long_option:
835 @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT)) \
836 | grep -Ev 'const struct option|struct option const' && { \
837 echo 1>&2 '$(ME): add "const" to the above declarations'; \
838 exit 1; } || :
839
840 NEWS_hash = \
841 $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
842 $(srcdir)/NEWS \
843 | perl -0777 -pe \
844 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
845 | md5sum - \
846 | sed 's/ .*//')
847
848 # Ensure that we don't accidentally insert an entry into an old NEWS block.
849 sc_immutable_NEWS:
850 @if test -f $(srcdir)/NEWS; then \
851 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
852 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
853 fi
854
855 # Update the hash stored above. Do this after each release and
856 # for any corrections to old entries.
857 update-NEWS-hash: NEWS
858 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
859 $(srcdir)/cfg.mk
860
861 # Ensure that we use only the standard $(VAR) notation,
862 # not @...@ in Makefile.am, now that we can rely on automake
863 # to emit a definition for each substituted variable.
864 # We use perl rather than "grep -nE ..." to exempt a single
865 # use of an @...@-delimited variable name in src/Makefile.am.
866 # Allow the package to add exceptions via a hook in cfg.mk;
867 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
868 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
869 _makefile_at_at_check_exceptions ?=
870 sc_makefile_at_at_check:
871 @perl -ne '/\@[A-Z_0-9]+\@/'$(_makefile_at_at_check_exceptions) \
872 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
873 $$($(VC_LIST_EXCEPT) | grep -E '(^|/)Makefile\.am$$') \
874 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
875
876 news-check: NEWS
877 if head $(srcdir)/NEWS | grep -E $(news-check-regexp) \
878 >/dev/null; then \
879 :; \
880 else \
881 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
882 exit 1; \
883 fi
884
885 sc_makefile_TAB_only_indentation:
886 @prohibit='^ [ ]{8}' \
887 in_vc_files='akefile|\.mk$$' \
888 halt='found TAB-8-space indentation' \
889 $(_sc_search_regexp)
890
891 sc_m4_quote_check:
892 @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
893 in_vc_files='(^configure\.ac|\.m4)$$' \
894 halt='quote the first arg to AC_DEF*' \
895 $(_sc_search_regexp)
896
897 fix_po_file_diag = \
898 'you have changed the set of files with translatable diagnostics;\n\
899 apply the above patch\n'
900
901 # Verify that all source files using _() are listed in po/POTFILES.in.
902 po_file = po/POTFILES.in
903 sc_po_check:
904 @if test -f $(po_file); then \
905 grep -E -v '^(#|$$)' $(po_file) \
906 | grep -v '^src/false\.c$$' | sort > $@-1; \
907 files=; \
908 for file in $$($(VC_LIST_EXCEPT)) lib/*.[ch]; do \
909 test -r $$file || continue; \
910 case $$file in \
911 *.m4|*.mk) continue ;; \
912 *.?|*.??) ;; \
913 *) continue;; \
914 esac; \
915 case $$file in \
916 *.[ch]) \
917 base=`expr " $$file" : ' \(.*\)\..'`; \
918 { test -f $$base.l || test -f $$base.y; } && continue;; \
919 esac; \
920 files="$$files $$file"; \
921 done; \
922 grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
923 | sort -u > $@-2; \
924 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
925 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
926 rm -f $@-1 $@-2; \
927 fi
928
929 # Sometimes it is useful to change the PATH environment variable
930 # in Makefiles. When doing so, it's better not to use the Unix-centric
931 # path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
932 msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
933 sc_makefile_path_separator_check:
934 @prohibit='PATH[=].*:' \
935 in_vc_files='akefile|\.mk$$' \
936 halt=$(msg) \
937 $(_sc_search_regexp)
938
939 # Check that `make alpha' will not fail at the end of the process.
940 writable-files:
941 if test -d $(release_archive_dir); then :; else \
942 for file in $(distdir).tar.gz \
943 $(release_archive_dir)/$(distdir).tar.gz; do \
944 test -e $$file || continue; \
945 test -w $$file \
946 || { echo ERROR: $$file is not writable; fail=1; }; \
947 done; \
948 test "$$fail" && exit 1 || : ; \
949 fi
950
951 v_etc_file = lib/version-etc.c
952 sample-test = tests/sample-test
953 texi = doc/$(PACKAGE).texi
954 # Make sure that the copyright date in $(v_etc_file) is up to date.
955 # Do the same for the $(sample-test) and the main doc/.texi file.
956 sc_copyright_check:
957 @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \
958 in_files=$(v_etc_file) \
959 halt='out of date copyright in $(v_etc_file); update it' \
960 $(_sc_search_regexp)
961 @require='# Copyright \(C\) '$$(date +%Y)' Free' \
962 in_vc_files=$(sample-test) \
963 halt='out of date copyright in $(sample-test); update it' \
964 $(_sc_search_regexp)
965 @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free' \
966 in_vc_files=$(texi) \
967 halt='out of date copyright in $(texi); update it' \
968 $(_sc_search_regexp)
969
970 # If tests/help-version exists and seems to be new enough, assume that its
971 # use of init.sh and path_prepend_ is correct, and ensure that every other
972 # use of init.sh is identical.
973 # This is useful because help-version cross-checks prog --version
974 # with $(VERSION), which verifies that its path_prepend_ invocation
975 # sets PATH correctly. This is an inexpensive way to ensure that
976 # the other init.sh-using tests also get it right.
977 _hv_file ?= $(srcdir)/tests/help-version
978 _hv_regex_weak ?= ^ *\. .*/init\.sh"
979 _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
980 sc_cross_check_PATH_usage_in_tests:
981 @if test -f $(_hv_file); then \
982 grep -l 'VERSION mismatch' $(_hv_file) >/dev/null \
983 || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2; \
984 exit 0; }; \
985 grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null \
986 || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
987 exit 1; }; \
988 good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file)); \
989 grep -LFx "$$good" \
990 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT))) \
991 | grep . && \
992 { echo "$(ME): the above files use path_prepend_ inconsistently" \
993 1>&2; exit 1; } || :; \
994 fi
995
996 # #if HAVE_... will evaluate to false for any non numeric string.
997 # That would be flagged by using -Wundef, however gnulib currently
998 # tests many undefined macros, and so we can't enable that option.
999 # So at least preclude common boolean strings as macro values.
1000 sc_Wundef_boolean:
1001 @prohibit='^#define.*(yes|no|true|false)$$' \
1002 in_files='$(CONFIG_INCLUDE)' \
1003 halt='Use 0 or 1 for macro values' \
1004 $(_sc_search_regexp)
1005
1006 sc_vulnerable_makefile_CVE-2009-4029:
1007 @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1008 in_files=$$(find $(srcdir) -name Makefile.in) \
1009 halt='the above files are vulnerable; beware of running\n'\
1010 '"make dist*" rules, and upgrade to fixed automake\n'\
1011 'see http://bugzilla.redhat.com/542609 for details' \
1012 $(_sc_search_regexp)
1013
1014 vc-diff-check:
1015 (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1016 if test -s vc-diffs; then \
1017 cat vc-diffs; \
1018 echo "Some files are locally modified:" 1>&2; \
1019 exit 1; \
1020 else \
1021 rm vc-diffs; \
1022 fi
1023
1024 rel-files = $(DIST_ARCHIVES)
1025
1026 gnulib_dir ?= $(srcdir)/gnulib
1027 gnulib-version = $$(cd $(gnulib_dir) && git describe)
1028 bootstrap-tools ?= autoconf,automake,gnulib
1029
1030 # If it's not already specified, derive the GPG key ID from
1031 # the signed tag we've just applied to mark this release.
1032 gpg_key_ID ?= \
1033 $$(git cat-file tag v$(VERSION) > .ann-sig \
1034 && gpgv .ann-sig - < /dev/null 2>&1 \
1035 | sed -n '/.*key ID \([0-9A-F]*\)/s//\1/p'; rm -f .ann-sig)
1036
1037 translation_project_ ?= coordinator@translationproject.org
1038 announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1039 announcement_mail_headers_ ?= \
1040 To: info-gnu@gnu.org \
1041 Cc: $(announcement_Cc_) \
1042 Mail-Followup-To: $(PACKAGE_BUGREPORT)
1043
1044 announcement: NEWS ChangeLog $(rel-files)
1045 @$(build_aux)/announce-gen \
1046 --mail-headers='$(announcement_mail_headers_)' \
1047 --release-type=$(RELEASE_TYPE) \
1048 --package=$(PACKAGE) \
1049 --prev=$(PREV_VERSION) \
1050 --curr=$(VERSION) \
1051 --gpg-key-id=$(gpg_key_ID) \
1052 --news=$(srcdir)/NEWS \
1053 --bootstrap-tools=$(bootstrap-tools) \
1054 --gnulib-version=$(gnulib-version) \
1055 --no-print-checksums \
1056 $(addprefix --url-dir=, $(url_dir_list))
1057
1058 ## ---------------- ##
1059 ## Updating files. ##
1060 ## ---------------- ##
1061
1062 ftp-gnu = ftp://ftp.gnu.org/gnu
1063 www-gnu = http://www.gnu.org
1064
1065 upload_dest_dir_ ?= $(PACKAGE)
1066 emit_upload_commands:
1067 @echo =====================================
1068 @echo =====================================
1069 @echo "$(build_aux)/gnupload $(GNUPLOADFLAGS) \\"
1070 @echo " --to $(gnu_rel_host):$(upload_dest_dir_) \\"
1071 @echo " $(rel-files)"
1072 @echo '# send the ~/announce-$(my_distdir) e-mail'
1073 @echo =====================================
1074 @echo =====================================
1075
1076 noteworthy = * Noteworthy changes in release ?.? (????-??-??) [?]
1077 define emit-commit-log
1078 printf '%s\n' 'post-release administrivia' '' \
1079 '* NEWS: Add header line for next release.' \
1080 '* .prev-version: Record previous version.' \
1081 '* cfg.mk (old_NEWS_hash): Auto-update.'
1082 endef
1083
1084 .PHONY: no-submodule-changes
1085 no-submodule-changes:
1086 if test -d $(srcdir)/.git; then \
1087 diff=$$(cd $(srcdir) && git submodule -q foreach \
1088 git diff-index --name-only HEAD) \
1089 || exit 1; \
1090 case $$diff in '') ;; \
1091 *) echo '$(ME): submodule files are locally modified:'; \
1092 echo "$$diff"; exit 1;; esac; \
1093 else \
1094 : ; \
1095 fi
1096
1097 .PHONY: alpha beta stable
1098 ALL_RECURSIVE_TARGETS += alpha beta stable
1099 alpha beta stable: $(local-check) writable-files no-submodule-changes
1100 test $@ = stable \
1101 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
1102 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1103 || :
1104 $(MAKE) vc-diff-check
1105 $(MAKE) news-check
1106 $(MAKE) distcheck
1107 $(MAKE) dist XZ_OPT=-9ev
1108 $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1109 $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1110
1111 # Override this in cfg.mk if you follow different procedures.
1112 release-prep-hook ?= release-prep
1113
1114 .PHONY: release-prep
1115 release-prep:
1116 case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1117 *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
1118 $(MAKE) -s announcement > ~/announce-$(my_distdir)
1119 if test -d $(release_archive_dir); then \
1120 ln $(rel-files) $(release_archive_dir); \
1121 chmod a-w $(rel-files); \
1122 fi
1123 echo $(VERSION) > $(prev_version_file)
1124 $(MAKE) update-NEWS-hash
1125 perl -pi -e '$$. == 3 and print "$(noteworthy)\n\n\n"' NEWS
1126 $(emit-commit-log) > .ci-msg
1127 $(VC) commit -F .ci-msg -a
1128 rm .ci-msg
1129
1130 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1131 # if the default $(PACKAGE)-derived name doesn't apply.
1132 gendocs_options_ ?=
1133
1134 .PHONY: web-manual
1135 web-manual:
1136 @test -z "$(manual_title)" \
1137 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1138 @cd '$(srcdir)/doc'; \
1139 $(SHELL) ../build-aux/gendocs.sh $(gendocs_options_) \
1140 -o '$(abs_builddir)/doc/manual' \
1141 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1142 "$(PACKAGE_NAME) - $(manual_title)"
1143 @echo " *** Upload the doc/manual directory to web-cvs."
1144
1145 # Code Coverage
1146
1147 init-coverage:
1148 $(MAKE) $(AM_MAKEFLAGS) clean
1149 lcov --directory . --zerocounters
1150
1151 COVERAGE_CCOPTS ?= "-g --coverage"
1152 COVERAGE_OUT ?= doc/coverage
1153
1154 build-coverage:
1155 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1156 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1157 mkdir -p $(COVERAGE_OUT)
1158 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1159 --capture
1160
1161 gen-coverage:
1162 genhtml --output-directory $(COVERAGE_OUT) \
1163 $(COVERAGE_OUT)/$(PACKAGE).info \
1164 --highlight --frames --legend \
1165 --title "$(PACKAGE_NAME)"
1166
1167 coverage: init-coverage build-coverage gen-coverage
1168
1169 # Update gettext files.
1170 PACKAGE ?= $(shell basename $(PWD))
1171 PO_DOMAIN ?= $(PACKAGE)
1172 POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1173 PODIR ?= po
1174 refresh-po:
1175 rm -f $(PODIR)/*.po && \
1176 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1177 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1178 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1179 echo 'en@quot' >> $(PODIR)/LINGUAS && \
1180 ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1181
1182 # Running indent once is not idempotent, but running it twice is.
1183 INDENT_SOURCES ?= $(C_SOURCES)
1184 .PHONY: indent
1185 indent:
1186 indent $(INDENT_SOURCES)
1187 indent $(INDENT_SOURCES)
1188
1189 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1190 # put the assignments in this variable.
1191 update-copyright-env ?=
1192
1193 # Run this rule once per year (usually early in January)
1194 # to update all FSF copyright year lists in your project.
1195 # If you have an additional project-specific rule,
1196 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1197 # By default, exclude all variants of COPYING; you can also
1198 # add exemptions (such as ChangeLog..* for rotated change logs)
1199 # in the file .x-update-copyright.
1200 .PHONY: update-copyright
1201 update-copyright:
1202 grep -l -w Copyright \
1203 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1204 | $(update-copyright-env) xargs $(build_aux)/$@